# -*- coding: utf-8 -*-
import sys
from PyQt5.QtWidgets import *
from PyQt5 import uic
from PyQt5.QtGui import *
import hashlib
from Crypto.Cipher import AES # 대칭키를 사용하기 위한 모듈 임포트

form_class = uic.loadUiType("gui_encryption_program4.ui")[0]

class MyWindow(QMainWindow, form_class):
    def __init__(self):
        global pad, unpad
        super().__init__()
        BS = 16 # blocksize를 16바이트로 고정시켜야 함(AES의 특징)

        # AES에서는 블럭사이즈가 128bit 즉 16byte로 고정되어 있어야 하므로 문자열을 encrypt()함수 인자로 전달시
        # 입력 받은 데이터의 길이가 블럭사이즈의 배수가 아닐때 아래와 같이 패딩을 해주어야 한다.
        # 패딩: 데이터의 길이가 블럭사이즈의 배수가 아닐때 마지막 블록값을 추가해 블록사이즈의 배수로 맞추어 주는 행위
        pad = (lambda s: s+ (BS - len(s) % BS) * chr(BS - len(s) % BS).encode())
        unpad = (lambda s: s[:-ord(s[len(s)-1:])])

        self.setFixedSize(700,700)
        self.setWindowIcon(QIcon("pagichacha.png"))
        self.setupUi(self)

        self.pushButton_3.clicked.connect(self.test)


    def test(self):
        key = self.make_key()
        print(key)


    ##################################################################################
    # 1. 키(패스워드) 생성 + 해시 처리
    ##################################################################################
    def make_key(self):
        global key
        self.textEdit.clear()

        key_org = self.lineEdit_4.text()
        self.textEdit.append("1. 원본 키(key) : "+key_org)

        self.key = hashlib.sha256(key_org.encode()).digest()
        print("AES Key(Key 문장 암호화) : ", self.key)
        self.textEdit.append("2. Key에 해시 적용 후 결과 : "+str(self.key)+"\n")


        return self.key


app=QApplication(sys.argv)
window = MyWindow()
window.show()
print("Before event loop")
app.exec_()
print("After event loop")